﻿Public Class frmGLAV
    Dim FILE1, FILE2, FILE3, COT As String

    Private Sub btnOPEN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOPEN.Click
        Dim file As String
        Dim dr As DialogResult
        dr = Me.dlgOPEN.ShowDialog()
        If (dr = System.Windows.Forms.DialogResult.OK) Then
            btnOPEN.Text = "Ждите..."
            For Each file In Me.dlgOPEN.FileNames
                FILE1 = file : IzmenIma()
            Next file
            btnOPEN.Text = "Загрузить файлы"
        End If
    End Sub

    Private Sub btnEXIT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEXIT.Click
        End
    End Sub

    Public Sub New()
        InitializeComponent()
        AnalizKomStroki()
        If FILE1 <> "" Then IzmenIma() : End
        InitializeOpenFileDialog()
    End Sub

    Private Sub InitializeOpenFileDialog()
        Me.dlgOPEN.Filter = "Web files (*.css;*.js;*.htm;*.html)|*.css;*.js;*.htm;*.html|All files (*.*)|*.*"
        Me.dlgOPEN.Multiselect = True
        Me.dlgOPEN.FilterIndex = 1
        Me.dlgOPEN.FileName = ""
        Me.dlgOPEN.Title = "Выберите один или несколько файлов"
    End Sub

    Private Sub ConvertFile()
        Dim A, B, I, J, N, NT, NOM1, NOM2 As Integer
        Dim STROKA, TEMP(100), STROKI(32000) As String
        NOM1 = FreeFile() : FileOpen(NOM1, FILE1, OpenMode.Input) : N = 0 : STROKA = ""
        While Not EOF(NOM1)
            N = N + 1 : STROKA = LineInput(NOM1) : STROKI(N) = STROKA
        End While
        FileClose(NOM1)
        For I = 1 To N
            STROKA = STROKI(I) : A = 1
            Do
                B = InStr(A, STROKA, Chr(9))
                If B > 0 Then STROKA = Mid(STROKA, A, B - A) + Chr(32) + Mid(STROKA, B + 1)
            Loop While B > 0
            STROKA = Trim(STROKA) : STROKI(I) = STROKA
        Next I
        NT = 1
        For J = 1 To 100
            TEMP(J) = ""
            For I = NT To N
                If Len(TEMP(J) + STROKI(I)) > 1000000 Then NT = I : Exit For
                TEMP(J) = TEMP(J) + STROKI(I)
            Next I
            If I > N Then NT = J : Exit For
        Next J
        NOM2 = FreeFile() : FileOpen(NOM2, FILE2, OpenMode.Output)
        For I = 1 To NT : Print(NOM2, TEMP(I) + Chr(13) + Chr(10)) : Next I
        FileClose(NOM2)
    End Sub

    Private Sub AnalizKomStroki()
        If Command() = "" Then Exit Sub
        For Each Me.COT In My.Application.CommandLineArgs
            FILE1 = Me.COT
        Next
    End Sub

    Private Sub IzmenIma()
        Dim filePath, fileName As String
        Dim ImaFile As System.IO.FileInfo
        On Error GoTo EROBR
        ImaFile = My.Computer.FileSystem.GetFileInfo(FILE1)
        filePath = ImaFile.DirectoryName
        fileName = ImaFile.Name
        FILE2 = filePath + fileName + ".tmp"
        FILE3 = filePath + fileName + ".bak"
        ConvertFile()
        If Dir(FILE3) <> "" Then Kill(FILE3)
        Rename(FILE1, FILE3)
        Rename(FILE2, FILE1)
        Exit Sub
EROBR:
        If Me.COT = "" Then MsgBox("Ошибка выполнения, проблема с файлами", MsgBoxStyle.Critical)
        End
    End Sub

    Private Sub btnHELP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHELP.Click
        Dim VREM As String
        VREM = "Программа 'text2line.exe' (текущая версия 1 от 27.03.18)." + Chr(13)
        VREM = VREM + "" + Chr(13)
        VREM = VREM + "Программа предназначена для вытягивания в одну линию "
        VREM = VREM + "содержимого файлов стилей, скриптов и кода страниц сайтов, "
        VREM = VREM + "то есть текстовых файлов типа 'css', 'js', 'htm' и т.д." + Chr(13)
        VREM = VREM + "Файл сохраняется под тем же именем, но первоначальная версия "
        VREM = VREM + "сохраняется в файле с добавлением к имени расширения 'bak'." + Chr(13)
        VREM = VREM + "" + Chr(13)
        VREM = VREM + "Программу можно вызывать из консоли с указанием в качестве "
        VREM = VREM + "параметра одного имени преобразуемого файла." + Chr(13)
        VREM = VREM + "Если используется оконный режим (запуск без параметров), то "
        VREM = VREM + "в диалоге выбора имен можно сразу выбрать несколько файлов." + Chr(13)
        VREM = VREM + "" + Chr(13)
        VREM = VREM + "Программа предназначена для свободного распространения." + Chr(13)
        VREM = VREM + "" + Chr(13)
        VREM = VREM + "Автор программы Э.Г.Гаузер, сайт автора - 'http://erichware.vgd.name'." + Chr(13)
        VREM = VREM + "Подробное описание программы и особенности ее применения читайте на "
        VREM = VREM + "странице программы - 'https://erichware.com/inform/text2line.htm'."
        MsgBox(VREM)
    End Sub

    Private Sub frmGLAV_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        MsgBox("Для выхода из программы используйте кнопку 'Выход'")
        e.Cancel = True
    End Sub

End Class
